unit T3dpanel;

{

Author : John Wilson
Version 1.4
Date : January '97


This component is freeware and must be treated as such, i.e. no liability for any
damage of any kind will be accepted by me. It was written when I was first
starting to understand VCL's and how they worked
(as you can se by the number of comments in the code)
You can look at this component as a beginner's guide to modifying existing components :-).

This component is a descendant of TPanel,
similar to the buttons found in MSIE which become raised when the mouse moves  over
them.
There are a couple of new added properties.
ClickColor : The color the panel changes to when you click on it
             (I adjusted the OnMouseDown)
ResetColor : The color that the panel changes (or reverts to)
             when "unclicked" (Modified OnMouseUp)
ResetBevel : The way the bevel changes when the mouse is moved off the panel.
             This is actually determined by where the cursor is ( found by the function
             getcursorpos() ) generally as the mouse moves off the inner bevel on
             the way out of the component (thickish bevels are recommended (4-5 pixels).
ToInnerBevel : Inner bevel that it is changed to when the mouse moves over it.

***************
New Additions:
***************

FocusColor 	: The colour that the panel caption changes to when the mouse moves over the 
		  panel. i.e. when the panel gets "Focus"
UnFocusColour	: The colour that the panel caption returns to when the mouse moves off it.

This component will install as a 3DPanel on a tab named "Visuals". If you want to change this,
go right ahead :).

As a small (and simple)  example,
1. drop the 3dpanel on a form (make it quite big), set the bevelwidth to 10
2. Set OuterBevel to bvRaised
3. Set InnerBevel to bvLowered
4. Set Clickcolor to clAqua
5. Leave ResetColor alone for now
6. Set ToInnner Bevel to bvNone
7. Set ResetBevel to bvLowered.
8. Set FocusColor to clBlue, set UnfocusColor to clWindowText
9. Run the program, move the mouse over the panel, you will see it raise itself to a
   platform looking thing, with the caption color changing. 
   Move the mouse off it and it will return to it's previous state.
   Click on it as well.
 
   Nifty eh ? It starts to look really cool when you pile a lot of them on top of each
   other in pyramid fashion.

If you have any other ideas or modifications you would like to make, please, go ahead, feel free.
I really would appreciate it though if you would please let me have a copy of the source so
that I can see what you did, and who knows, maybe have an improvment on yours :-).
Thank you for trying out this component, play with it, experiment with it and above all
HAVE FUN !
That's what Delphi is all about......

John
email : badkarma@pixie.co.za
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type
  TThreeDPanel = class(TPanel)
  private
    { Private declarations }
    fbevelinner : TPanelBevel;
    fbevelouter : TPanelBevel;
    fResetBevel : TPanelBevel;
    fcolor : TColor;
    fclickcolor : TColor;
    fresetcolor : TColor;
    ffocuscolor : TColor;
    funfocuscolor : TColor;
  protected
     { Protected declarations }
 {standard make it and then and break it calls}
  constructor Create(AOwner: TComponent); override;
  destructor destroy ; override;

  procedure setbevelinner(value : tpanelbevel);
  procedure resetbevelinner(value : tpanelbevel);
  procedure setbevelouter(value : tpanelbevel);
  procedure setclickcolor(value : TColor);
  procedure resetoldcolor(value : TColor);

{new procedures to change the caption colours)
  procedure setfocuscolor(value : TColor);
  procedure setunfocuscolor(value : TColor);

  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseMove(Shift: TShiftState;  X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;

  procedure Paint; override;              {in case you want to do any drawing on the panel}
  public
    { Public declarations }
 published
    { Published declarations }

    {
    "property"  places the property to be modified in the
    object inspector, remeber that events are properties too.
    }

 { property  OuterBevel : TPanelBevel read fbevelouter write setbevelouter;}
 {left this here in case you want to play with the outer bevel as well}

 property  ToInnerBevel : TPanelBevel read fbevelinner write setbevelinner;
 property  ResetBevel : TpanelBevel   read fResetBevel write resetbevelinner;
 property  ClickColor : TColor read fclickcolor write setclickcolor;
 property  ResetColor : Tcolor read fresetcolor write resetoldcolor;

{new properties}
 property  FocusColor : TColor read ffocuscolor write setfocuscolor;
 property  UnFocusColor : TColor read funfocuscolor write setunfocuscolor;


 end;

procedure Register;

implementation

procedure Register;
begin
{change 'Visuals' to whatever you like to put it on another page}
  RegisterComponents('Visuals', [TThreeDPanel]);
end;

constructor TThreeDPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  {create components and define default values for some of the new props}
  fresetcolor := clBtnFace;
  fresetbevel := bvNone;
  ffocuscolor := clWindowText;
  funfocuscolor := clWindowText;
end;

procedure TThreeDPanel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{change the colour of the panel when clicked on}
color := fclickcolor;
inherited MouseDown(Button, Shift, X, Y);
end;


procedure TThreeDPanel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{change colour back to what it was}
color := fresetcolor;
inherited MouseUp(Button, Shift, X, Y);
end;

procedure TThreeDPanel.MouseMove(Shift: TShiftState;  X, Y: Integer);
var point : tpoint;
begin
getcursorpos(point);                    { duh }
point := screentoclient(point);         {convert screen co-ords to co-ords over panel}
{caption := inttostr(point.x) + ',' + inttostr(point.y);} { for debugging, show co-ordinates}
if (point.x <= bevelwidth) or (point.x >= width - bevelwidth) or
   (point.y <= bevelwidth) or (point.y >= height - bevelwidth)   then
begin
{if point falls ouside inner bevel then reset bevel to what it was}
bevelinner := fresetbevel;
{return caption color to reflect movement of mouse off the panel}
font.color := UnFocusColor;
end
else
begin
{else, change the inner bevel to reflect the mouse's movement}
bevelinner := ToInnerBevel;
{change caption color to reflect movement of mouse over the panel}
font.color := FocusColor;
end;
{call programmatically assigned MouseMove event {if any}
inherited MouseMove(Shift, X, Y);
end;


procedure TThreeDPanel.Paint;
begin
{for drawing stuff, if you don't know what this is yet, go and read up on it,
this line doesn nothing at the moment. Just in case you want to draw anything on the panel,
like polka dots or tartan things :) }
inherited Paint;
end;


procedure TThreeDPanel.ResetBevelInner(Value : TPanelBevel);
begin
{value is the value to which the TPanelBevel should change to. This is defined by the mouse's
movement, just keeps the panel updated as the mouse moves on and off the panel}
 if fresetbevel <> Value then
  begin
    fresetbevel := Value;
    Invalidate;
    {invalidate calls the paint method, i.e. makes the "window" (3dPanel in this case)
    "invalid" or "damaged" and forces windows to repaint the control 
    (with a windows message "WM_PAINT").
    Since all of Windows is a huge game of "Simon says", this forces the panel to be updated.
    When it does this, you see the control being modified on the form.
    (Here the panel is repainted when the mouse moves off it.}
  end;
end;

procedure TThreeDPanel.SetBevelInner(Value : TPanelBevel);
begin
 if fbevelinner <> Value then
  begin
    fbevelinner := Value;
    Invalidate;
  end;
end;

procedure TThreeDPanel.SetBevelOuter(Value : TPanelBevel);
begin
 if fbevelouter <> Value then
  begin
    fbevelouter := Value;
    Invalidate;
  end;
end;

procedure TThreeDPanel.setclickcolor(Value : Tcolor);
begin
  if fclickcolor <> value then
   begin
    fclickcolor := value;
    invalidate;
   end;
end;

procedure TThreeDPanel.setfocuscolor(Value : Tcolor);
begin
  if ffocuscolor <> value then
   begin
    ffocuscolor := value;
    invalidate;
   end;
end;

procedure TThreeDPanel.setunfocuscolor(Value : Tcolor);
begin
  if funfocuscolor <> value then
   begin
    funfocuscolor := value;
    invalidate;
   end;
end;

procedure TThreeDPanel.resetoldcolor(Value : Tcolor);
begin
  if fresetcolor <> value then
   begin
    fresetcolor := value;
    invalidate;
   end;
end;


destructor TThreeDPanel.Destroy;
begin
{ Dispose of the object when the form it is resting on is destroyed}
  inherited Destroy;
end;


end.
